hider
	var
		const
			FadeTime = 5
			HiddenAlpha = 32

		list
			fade_images
			fade_ids

	proc
		IsHidingAnything()
			return fade_images != null

		HideFrom(atom/atom, client/client)
			// Cancel fade-in if it's happening.
			if(fade_ids)
				fade_ids -= atom
				if(!fade_ids.len) fade_ids = null

			// Initialize fade image if necessary.
			var/image/fade = GetFadeImage(atom)
			if(!fade)
				fade = InitializeFadeImage(atom)
				client.images += fade

			// Fade out.
			AnimateFadeOut(fade)

		UnhideFrom(atom/atom, client/client)
			// Get the fade image, if any, for the given atom.
			var/image/fade = GetFadeImage(atom)

			// No fade image means this atom isn't faded out, so, nothing to do.
			if(!fade) return

			// Allow fade-in to be canceled.
			if(!fade_ids) fade_ids = new
			var/datum/fade_id = new
			fade_ids[atom] = fade_id

			// Fade in.
			AnimateFadeIn(fade)

			// Fade-in was canceled.
			if(!fade_ids || fade_ids[atom] != fade_id) return

			// Finish fade-in.
			fade_ids -= atom
			if(!fade_ids.len) fade_ids = null

			// Dispose of the fade image.
			client?.images -= fade
			DisposeFadeImage(atom)

		AnimateFadeOut(image/fade)
			animate(fade, time = FadeTime, easing = EASE_OUT | SINE_EASING, alpha = HiddenAlpha)
			sleep FadeTime

		AnimateFadeIn(image/fade)
			animate(fade, time = FadeTime, easing = EASE_IN | SINE_EASING, alpha = 255)
			sleep FadeTime

		NewFadeImage(atom/atom)
			var/image/i = image(atom, atom)
			i.override = TRUE
			i.appearance_flags |= RESET_COLOR | RESET_ALPHA | RESET_TRANSFORM
			return i

		InitializeFadeImage(atom/atom)
			if(!fade_images) fade_images = new
			return fade_images[atom] = NewFadeImage(atom)

		DisposeFadeImage(atom/atom)
			if(!fade_images) return
			fade_images -= atom
			if(!fade_images.len) fade_images = null

		GetFadeImage(atom/atom)
			return fade_images && fade_images[atom]
